<template lang="pug">
input.input( 
	:value='modelValue'
	@input='handleInput'
	:placeholder='placeholder'
	:type='inputType'
	:class='bindClass'
	:disabled='disabled' )
</template>

<script setup>
import { computed } from "vue"

const props = defineProps({
	modelValue: {
		type: [ String, Number ],
		default: ""
	},
	placeholder: {
		type: String,
		default: ""
	},
	inputType: {
		type: String,
		default: "text"
	},
	type: {
		type: String,
		default: ""
	},
	size: {
		type: String,
		default: "",
		validator: val => ["", "small", "normal", "medium", "large"].includes(val)
	},
	disabled: Boolean
})
const emit = defineEmits([ "update:modelValue" ])

const bindClass = computed(() => [ 
	props.type ? `is-${props.type}` : "",
	props.size ? `is-${props.size}` : ""
])

const handleInput = ({ target: { value } }) => emit("update:modelValue", value)
</script>